###### R pojedenct (linern regrese)######

setwd("C:/Users/Navratil/Documents/R")
# setwd("C:/Users/uivatel/Documents/R") # cesta pro koln PC

library(readxl)

ostrorep <- read_excel("C:/Users/Navratil/Documents/Navratil/ZF/Statistika/korelace.xlsx")
# ostrorep <- read_excel("E:/R/korelace.xlsx") # cesta k datm na Vaich flekch
ostrorep <- as.data.frame(ostrorep) # vytvome ze vstupnch dat datovou tabulku


####Jednoduch linern regrese####

# Linern regrese m v R vestavnou funkci lm()

# kol: Existuje zvislost mnostv samc ostrorepa zavench pi pen
# na ce krune samice?

plot(ostrorep$samice.sirka, ostrorep$samci.biomasa) # grafick vyjden

cor(ostrorep$samice.sirka, ostrorep$samci.biomasa) # Pearsonv k.k.=0,339

# Vazba mezi promnnmi je, zkusme ji kvantifikovat regres:

samci1 <- lm(ostrorep$samci.biomasa~ostrorep$samice.sirka) # ulome vsledek

summary(samci1)

# Vsledek - test modelu (je na poslednm dku):
# F-statistic: 22.34 on 1 and 171 DF,  p-value: 4.76e-06
# model je statisticky prkazn

# Vsledek - mra vysvtlen variability (je na pedposlednm dku):
# Multiple R-squared:  0.1155,	Adjusted R-squared:  0.1104 
# ka samice vysvtluje 11,04% variability dat o biomase zavench samc -
# - je to hodnota Adjusted R-squared

# Vsledek - regresn rovnice - zjist se z tohoto:
# Coefficients:
#                    Estimate Std. Error t value Pr(>|t|)    
# (Intercept)        -25.435      6.911  -3.680 0.000312 ***
# data$samice.sirka    1.238      0.262   4.726 4.76e-06 ***
# rovnice je: biomasa samc = -25,435 + 1.238*ka samice
# koeficient ky samice se vysoce prkazn li od nuly (= posledn sloupec)

# Grafick vyjden linern regrese:

plot(ostrorep$samice.sirka, ostrorep$samci.biomasa)
abline(samci1, col=2, lwd=3) # vlo regresn pmku do pedchozho grafu



###Regresn diagnostika###

# Posuzujeme normalitu rezidul a jeich zvislost na velikosti men hodnoty
# Grafy regresn diagnostiky se volaj funkc plot(), kter zde ale m jin 
# charakter zobrazen vsledk - graf je povcero a zobrazuj se po zmknut
# klvesy "Enter" - Hit <Return> to see next plot v Console

plot(samci1)

# 1: Residuals vc. Fitted zobraz reziduly oproti dan hodnot na regresn pmce
#    linie by mla bt rovn a body tvoit oblak bez odlehlch hodnot - tady ti mme;
#    rozptyl rezidul nem rst s rostouc hodnotou Fitted; pokud navc data nejsou
#    v linern zvislosti, tak linie v tomto grafu tvo kivku
# 2: Normal Q-Q - ten znme, body by mly bt kolem pmky (zde se jedn o posouzen 
#   normality rezidul)
# 3: Scale-Location - zvislost rezidul na hodnot Fitted - nesm kontinuln rst;
#    pokud navc data nejsou v linern zvislosti, tak linie v tomto grafu tvo kivku
# 4: Residuals vs. Leverage - nebudeme pouvat

# Diagnostikou byla potvrzena vhodnost modelu, ale identifikovna byla ti odlehl
# men - mli bychom se podvat, o jak men jde a, pokud si to okolnostmi
# meme dovolit, tato men odstarnit a pepotat model znovu.


####Mnohonsobn linern regrese####

# Prci si vysvtlme na pkladu dat z raelini a budeme se snait vysvtlit druhovou 
# bohatost na lokalitch (promnn = richness)

rich <- read_excel("C:/Users/Navratil/Documents/Navratil/ZF/Statistika/data1.xlsx")
# rich <- read_excel("E:/R/data1.xlsx") # cesta k datm na Vaich flekch
rich <- as.data.frame(rich) # vytvome ze vstupnch dat datovou tabulku

# Testujme zvislos potu druh na pH, mnostv minerl, mnostv dusku a mnostv fosforu

reg.rich <- lm(rich$richness~rich$pH1+rich$c1+rich$NH4N1+rich$TP1)

summary(reg.rich)

# Vsledek: Test H0, e vechny koeficienty jsou 0 meme zamtnout:
# F-statistic: 3.322 on 4 and 16 DF,  p-value: 0.03674
# Vsledek: Statisticky vznamn vliv na druhovou bohatost m pouze pH
#                 Estimate Std. Error t value Pr(>|t|)  
# rich$pH1     9.953e+00  3.769e+00   2.641   0.0178 *

plot(reg.rich) # v grafu Scale-Location je identifikovna heteroskedasticita




####Vbr promnnch pro model####

# Clem mnohonsobn linern regrese je vytvoit model, kter je statisticky prkazn
# a zrove nejjednosu. Proto bysme se mli snait takov model vytvoit.

# V naem ppad vypadaj koeficienty takto:
#               Estimate Std. Error t value Pr(>|t|)  
# (Intercept) -2.648e+01  1.710e+01  -1.548   0.1412  
# rich$pH1     9.953e+00  3.769e+00   2.641   0.0178 *
# rich$c1      4.016e-04  3.732e-02   0.011   0.9915  
# rich$NH4N1   1.491e-03  7.002e-02   0.021   0.9833  
# rich$TP1     3.233e-03  3.662e-01   0.009   0.9931 
#. . . a F test takto:
# Residual standard error: 9.304 on 16 degrees of freedom
# Multiple R-squared:  0.4537,	Adjusted R-squared:  0.3171 
# F-statistic: 3.322 on 4 and 16 DF,  p-value: 0.03674

# Zd se, e vznamn je jen pH1 - vypotejme model jen pro nj:

reg.rich2 <- lm(rich$richness~rich$pH1)

summary(reg.rich2)

# Vsledek: SE je men, F statistika ve vrazn vy a adj.R2 je vrazn vy

# Zd se, e tento model je lep - k testu pouijeme F test obou model pomoc
# funkce anova()
# H0 zde je: Modely reg.rich a reg.rich2 se neli, alfa = 95%

anova(reg.rich2,reg.rich)

# Vsledek: 
#      Res.Df    RSS Df Sum of Sq     F Pr(>F)
# 1     19 1385.0                          
# 2     16 1384.9  3  0.044304 2e-04      1
# H0 nemohu zamtnout (p=1) a tedy oba modely se neli, reg.rich tak nen statisticky
# lep, je-li tomu tak, pak mohu pout model reg.rich2, protoe nen hor ne 
# reg.rich a zrove je jednodu

# Problm pedchozho postupu je v tom, e nevm, jak kombinace je nejlep, jsem
# schopen testovat jen jestli nco nen hor, proto je lep (pokud nerozhoduji
# mezi danmi dvma modely) vyut funkce step() a Forward a Backward selection 
# metody vbru promnnch do modelu.

# Jak  to funguje?
# 1.  Musme nadefinovat nulov model, kde richness bude pouze funkc interceptu

start <- lm(rich$richness~1)

# 2. Musme nadefinovat konen model, kde jsou vechny potenciln promnn

end <- lm(rich$richness~rich$pH1+rich$c1+rich$NH4N1+rich$TP1)

# 3. Spustme pkaz step, kde definujeme nejprve nulov model, zpsob vbru a konen
# model v atributu scope

step(start, direction = "forward", scope = formula(end))

# MOdel se vybr podle hodnot AIC (m men hodnota tm lpe). Nulov model m njak 
# AIC a pidnm rznch promnnch se AIC zmn, pokud se pdnm nkter promnn AIC 
# sn oproti poten, pak je tato promnn zaazena do modelu a AIC je pepotno,
# pokud by zaazen njak dal promnn do modelu stvajc AIC medelu zmenilo, je 
# tato promnn do modelu zaazena a tak to pokrauje, a by piazen promnn znamenalo
# zven AIC - dle u promnn piazovny do modelu nejsou a je nalezen optimln model.

# N vsledek:
# Start:  AIC=102.66
# rich$richness ~ 1
# 
#               Df Sum of Sq    RSS     AIC
# + rich$pH1    1   1149.99 1385.0  91.967
# + rich$c1     1    363.44 2171.5 101.412
# <none>                    2534.9 102.662
# + rich$TP1    1     89.83 2445.1 103.904
# + rich$NH4N1  1      8.28 2526.7 104.593
#
# Step:  AIC=91.97
# rich$richness ~ rich$pH1

# Df Sum of Sq    RSS    AIC
# <none>                    1385.0 91.967
# + rich$NH4N1  1  0.032593 1384.9 93.967
# + rich$c1     1  0.002644 1385.0 93.967
# + rich$TP1    1  0.000467 1385.0 93.967

# Call:
# lm(formula = rich$richness ~ rich$pH1)
# 
# Coefficients:
# (Intercept)     rich$pH1  
#  -26.345        9.978  

# Nejlep model tedy je: lm(rich$richness ~ rich$pH1)

# 4. Pokud mme vce promnnch vybranch do modelu, tak ty se mou liit 
# podle metody vbru, je tedy teba spustt stejn pkaz, ale s opanm vbrem, logicky zanm u end a 
# nemusm zadvat nulov model, k nmu by se program dopracoval sm

step(end, direction = "backward")

# Pak se vybere mezi vsledkem backward a forward ten, kter m men vsledn AIC